<?php
/**
 * @package   Essentials YOOtheme Pro 2.2.16 build 0813.1608
 * @author    ZOOlanders https://www.zoolanders.com
 * @copyright Copyright (C) Joolanders, SL
 * @license   http://www.gnu.org/licenses/gpl.html GNU/GPL
 */

namespace ZOOlanders\YOOessentials\Source\Provider\Xml;

use SimpleXMLElement;
use ZOOlanders\YOOessentials\Auth\AuthManager;
use function YOOtheme\app;

class XmlSourceUrl extends XmlSourceFile
{
    public const NAME = 'xml-url';

    protected string $configFile = 'config-url.json';

    protected function loadXml(): SimpleXMLElement
    {
        /** @var XmlService $xmlService */
        $xmlService = app(XmlService::class);

        $auth = null;
        if ($this->config('requires_auth')) {
            $auth = app(AuthManager::class)->auth($auth);
        }

        $cacheTime = self::getCacheTime($this, []);

        return $xmlService->loadFromUrl($this->config('url'), $auth, $cacheTime);
    }
}
